일 | 월 | 화 | 수 | 목 | 금 | 토 |
---|---|---|---|---|---|---|
1 | 2 | |||||
3 | 4 | 5 | 6 | 7 | 8 | 9 |
10 | 11 | 12 | 13 | 14 | 15 | 16 |
17 | 18 | 19 | 20 | 21 | 22 | 23 |
24 | 25 | 26 | 27 | 28 | 29 | 30 |
- socket
- 알고리즘
- React
- 프론트엔드 스쿨
- 프로그래머스
- 메모리 배리어
- 제로베이스
- 서버
- map
- 완전탐색
- 문자열&연산자
- 코딩테스트 스터디
- JavaScript
- 구조체
- MemoryBarrier
- 제로베이스 프론트엔드 스쿨
- 자바스크립트
- N과 M(2)
- C++
- dfs
- 백트래킹
- 구현
- 백준
- c#
- leetcode
- 멀티스레드
- BFS
- 코딩테스트
- Server
- Algorithm
- Today
- Total
Written
스터디 4주차 / leetcode 26번 / Remove Duplicates from Sorted Array / JavaScript 본문
스터디 4주차 / leetcode 26번 / Remove Duplicates from Sorted Array / JavaScript
steeringhead 2023. 2. 1. 16:37https://leetcode.com/problems/remove-duplicates-from-sorted-array/
Given an integer array nums sorted in non-decreasing order, remove the duplicates in-place such that each unique element appears only once. The relative order of the elements should be kept the same.
Since it is impossible to change the length of the array in some languages, you must instead have the result be placed in the first part of the array nums. More formally, if there are k elements after removing the duplicates, then the first k elements of nums should hold the final result. It does not matter what you leave beyond the first k elements.
Return k after placing the final result in the first k slots of nums.
Do not allocate extra space for another array. You must do this by modifying the input array in-place with O(1) extra memory.
Custom Judge:
The judge will test your solution with the following code:
int[] nums = [...]; // Input array
int[] expectedNums = [...]; // The expected answer with correct length
int k = removeDuplicates(nums); // Calls your implementation
assert k == expectedNums.length;
for (int i = 0; i < k; i++) {
assert nums[i] == expectedNums[i];
}
If all assertions pass, then your solution will be accepted.
Example 1:
Input: nums = [1,1,2]
Output: 2, nums = [1,2,_]
Explanation: Your function should return k = 2, with the first two elements of nums being 1 and 2 respectively.
It does not matter what you leave beyond the returned k (hence they are underscores).
Example 2:
Input: nums = [0,0,1,1,1,2,2,3,3,4]
Output: 5, nums = [0,1,2,3,4,_,_,_,_,_]
Explanation: Your function should return k = 5, with the first five elements of nums being 0, 1, 2, 3, and 4 respectively.
It does not matter what you leave beyond the returned k (hence they are underscores).
Constraints:
- 1 <= nums.length <= 3 * 104
- -100 <= nums[i] <= 100
- nums is sorted in non-decreasing order.
문제가 조금 장황하게 설명되어 있긴 하지만, 비교적 간단한 문제였습니다.
입력으로 주어지는 배열에서 중복되어있는 요소를 걷어내 하나만 남게하고, 데이터들의 순서는 원래의 상태를 유지하면서
0번 인덱스부터 차례대로 넣어서 입력으로 받은 배열을 재구성하고 그 길이를 출력하는 문제였습니다.
자바스크립트에는 Set이라는 훌륭한 도구가 있기 때문에 , 중복되는 데이터를 쉽게 제거할 수 있습니다.
Set은 객체를 반환하기 때문에 배열로 쓰기위해 Array.from()의 인자로 newSet을 전달해 newArr라는 배열을 만들었고,
입력으로 주어진 nums배열에 newArr에 담긴 값을 복사하여 nums를 재구성 해주고 길이를 반환하여 문제를 해결했습니다.
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
|
/**
* @param {number[]} nums
* @return {number}
*/
var removeDuplicates = function(nums) {
let newSet = new Set(nums);
let newArr = Array.from(newSet);
for (let i=0; i<newArr.length; i++)
{
nums[i] = newArr[i];
}
return newArr.length;
};
|
cs |
'알고리즘 문제풀이' 카테고리의 다른 글
스터디 4주차 / leetcode / Longest Palindromic Substring / JavaScript (0) | 2023.02.01 |
---|---|
스터디 4주차 / leetcode / Remove Element / JavaScript (2) | 2023.02.01 |
스터디 3주차 / leetcode 21번 / Merge Two Sorted Lists / JavaScript (0) | 2023.01.28 |
스터디 3주차 / leetcode 20번 / Valid parentheses / JavaScript (2) | 2023.01.28 |
코딩 테스트 스터디 기록 _ 2 (2) | 2023.01.19 |